<!-- eslint-disable no-debugger -->
<template>
  <div>
    <v-btn color="primary" @click="showtext = true"> Add </v-btn>

    <v-data-table v-model:items-per-page="itemsPerPage" :headers="headers" :items="items" item-value="Nation" @click:row="(item:any )=> showDetails(item)">
      <template v-slot:item.action="{ item, }">
        <v-btn @click="editData(item, items.indexOf(item.props.title))" class="edit-button button-right">
          Edit
        </v-btn>
        <v-btn @click="removeTask(items.indexOf(item.props.title))" class="remove-button button-right">
          Remove
        </v-btn>
      </template></v-data-table>

  </div>
  <div class="text-center">
    <v-dialog v-model="showtext" width="400px">
      <v-card>
        <v-card-text>
          <AddTodo :editdata="editTask" :index="editIndex" @addTask="addTask" @editTaskValue="editTaskValue" />
        </v-card-text>
        <v-card-actions>
          <v-btn color="primary" block @click="showtext = false">Close</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script lang="ts" setup>
import AddTodo from "./AddTodo.vue";
import router from "../router";
import { onMounted, ref } from "vue";
import { useCounterStore } from "@/stores/detailstate";
import axios from "axios";

const editIndex = ref(-1);
const editTask = ref("");
const messageVal = ref(useCounterStore());
const showtext = ref(false);
const items = ref([{ Nation: 'dfdf' }]);
const itemsPerPage = ref(5)
const headers = ref([
  {
    title: 'Message',
    align: 'start',
    sortable: false,
    key: 'Nation',
  }, { title: 'Send', key: 'action' }

])


onMounted(() => {
  axios.get('https://datausa.io/api/data?drilldowns=Nation&measures=Population').then((response) => {
    items.value = response.data.data
  })
})

function addTask(task: any) {
  showtext.value = false;
  items.value.push({ Nation: task });

}

function editData(item: any, index: number) {
  showtext.value = true;
  editTask.value = item.value
  debugger
  editIndex.value = index;
}

function editTaskValue(val: any) {
  showtext.value = false;
  items.value[editIndex.value].Nation = val;
  editIndex.value = -1;
  editTask.value = "";
}

function removeTask(index: number) {
  debugger
  items.value.splice(index, 1);
}

function showDetails(item: any) {
 debugger
  messageVal.value.$patch({ message: item.value });
  debugger
  // items.indexOf(item.props.title)
  router.push({
    path: "/details/" + 3,
  });
}
</script>

<style scoped>


ul {
  list-style-type: none;
  margin: 0;
  padding: 0;
  width: 500px;
}

li {
  background-color: lightgray;
  padding: 10px;
  margin: 10px 0;
  border-radius: 5px;
  width: 100%;
}

.button-right {
  float: right;
  color: white;
  padding: 3px 8px;
  border: none;
  border-radius: 5px;
  cursor: pointer;
  margin-left: 5px;
}

.edit-button {
  background-color: rgb(222, 107, 49);
}

.remove-button {
  background-color: rgb(229, 21, 21);
}

.remove-button:hover {
  background-color: rgb(77, 4, 4);
}

.edit-button:hover {
  background-color: rgb(104, 50, 8);
}

.add-button {
  background-color: green;
  /* set the background color of the button */
  color: white;
  /* set the text color of the button */
  padding: 10px 20px;
  /* add some padding to the button */
  border: none;
  /* remove the border around the button */
  border-radius: 5px;
  /* round the corners of the button */
  cursor: pointer;
  /* change the cursor to a pointer when hovering over the button */
}

.add-button:hover {
  background-color: darkgreen;
  /* change the background color when the button is hovered */
}
</style>
